<?php
/**
 * Intreface DAO
 *
 * @author: http://phpdao.com
 * @date: 2017-12-11 08:44
 */
interface TblEngagementPerDeptDAO{

	/**
	 * Get Domain object by primry key
	 *
	 * @param String $id primary key
	 * @Return TblEngagementPerDept 
	 */
	public function load($id);

	/**
	 * Get all records from table
	 */
	public function queryAll();
	
	/**
	 * Get all records from table ordered by field
	 * @Param $orderColumn column name
	 */
	public function queryAllOrderBy($orderColumn);
	
	/**
 	 * Delete record from table
 	 * @param tblEngagementPerDept primary key
 	 */
	public function delete($id);
	
	/**
 	 * Insert record to table
 	 *
 	 * @param TblEngagementPerDept tblEngagementPerDept
 	 */
	public function insert($tblEngagementPerDept);
	
	/**
 	 * Update record in table
 	 *
 	 * @param TblEngagementPerDept tblEngagementPerDept
 	 */
	public function update($tblEngagementPerDept);	

	/**
	 * Delete all rows
	 */
	public function clean();

	public function queryByEngagementId($value);

	public function queryByDeptId($value);

	public function queryByCreatedBy($value);

	public function queryByModifiedBy($value);

	public function queryByDateCreated($value);

	public function queryByDateModified($value);


	public function deleteByEngagementId($value);

	public function deleteByDeptId($value);

	public function deleteByCreatedBy($value);

	public function deleteByModifiedBy($value);

	public function deleteByDateCreated($value);

	public function deleteByDateModified($value);


}
?>