<?php
/**
 * Class that operate on table 'tbl_tba_per_eng'. Database Mysql.
 *
 * @author: http://phpdao.com
 * @date: 2017-12-05 08:24
 */
class TblTbaPerEngMySqlExtDAO extends TblTbaPerEngMySqlDAO{

	public function getUnmapped($deptid,$engid,$engtype){
		$sql = "
				SELECT
					 *
				FROM
					(		
						SELECT 
							*
						FROM 
						(
							SELECT 
								tba.id,
								tba.tba_no,
								tba.tba,
								tpe.eng_per_dept_id
							FROM 
								tbl_tba_per_eng tpe
							INNER JOIN 
								tbl_tba tba
							ON
								tpe.tba_id = tba.id
							INNER JOIN
								tbl_engagement_type tet
							ON 
								tet.id = tpe.eng_type_id
							INNER JOIN
								tbl_engagement_per_dept tepd
							ON
								tepd.id = tpe.eng_per_dept_id
							INNER JOIN
								tbl_department td
							ON
								td.id = tepd.dept_id
							INNER JOIN
								tbl_engagement te
							ON
								te.id = tepd.engagement_id
							WHERE
								td.id = $deptid
							AND
								tepd.id = $engid
							AND
								tet.id = $engtype 
							UNION
							
							SELECT 
								id,
								tba_no,
								tba,
								null
							FROM
							tbl_tba
							WHERE
								status = 'enabled'
						) a
							
						GROUP BY
							a.id
					)b
				WHERE
					b.eng_per_dept_id IS NULL
				ORDER BY
				b.id DESC
		";
		$sqlQuery = new SqlQuery($sql);
		return QueryExecutor::execute($sqlQuery);
	}
	public function getMapped($deptid,$engid,$engtype){
		$sql = "
				SELECT 
					tba.id,
					tba.tba_no,
					tba.tba,
					tpe.eng_per_dept_id
				FROM 
					tbl_tba_per_eng tpe
				INNER JOIN 
					tbl_tba tba
				ON
					tpe.tba_id = tba.id
				INNER JOIN
					tbl_engagement_type tet
				ON 
					tet.id = tpe.eng_type_id
				INNER JOIN
					tbl_engagement_per_dept tepd
				ON
					tepd.id = tpe.eng_per_dept_id
				INNER JOIN
					tbl_department td
				ON
					td.id = tepd.dept_id
				INNER JOIN
					tbl_engagement te
				ON
					te.id = tepd.engagement_id
				WHERE
					td.id = $deptid
				AND
					tepd.id = $engid
				AND
					tet.id = $engtype 
		";
		$sqlQuery = new SqlQuery($sql);
		return QueryExecutor::execute($sqlQuery);
	}
	public function checkAdd($engid,$engtype,$tbaid){
		$sql = "
				SELECT * FROM tbl_tba_per_eng WHERE eng_per_dept_id = $engid AND eng_type_id = $engtype AND tba_id = $tbaid
		";
		$sqlQuery = new SqlQuery($sql);
		return $this->getList($sqlQuery);
	}

	public function getTbaByEngagement($deptid,$engid,$engtype){
		$sql = "
				SELECT 
					tpe.id,
					tba.tba_no,
					tba.tba,
					tpe.eng_per_dept_id
				FROM 
					tbl_tba_per_eng tpe
				INNER JOIN 
					tbl_tba tba
				ON
					tpe.tba_id = tba.id
				INNER JOIN
					tbl_engagement_type tet
				ON 
					tet.id = tpe.eng_type_id
				INNER JOIN
					tbl_engagement_per_dept tepd
				ON
					tepd.id = tpe.eng_per_dept_id
				INNER JOIN
					tbl_department td
				ON
					td.id = tepd.dept_id
				INNER JOIN
					tbl_engagement te
				ON
					te.id = tepd.engagement_id
				WHERE
					td.id = $deptid
				AND
					tepd.id = $engid
				AND
					tet.id = $engtype 
		";
		$sqlQuery = new SqlQuery($sql);
		return QueryExecutor::execute($sqlQuery);
	}
}
?>