<?php

/**
 * DAOFactory
 * @author: http://phpdao.com
 * @date: ${date}
 */
class DAOFactory{
	
	/**
	 * @return ChatDAO
	 */
	public static function getChatDAO(){
		return new ChatMySqlExtDAO();
	}

	/**
	 * @return CitiesDAO
	 */
	public static function getCitiesDAO(){
		return new CitiesMySqlExtDAO();
	}

	/**
	 * @return ClClientsDAO
	 */
	public static function getClClientsDAO(){
		return new ClClientsMySqlExtDAO();
	}

	/**
	 * @return ClTransactionDAO
	 */
	public static function getClTransactionDAO(){
		return new ClTransactionMySqlExtDAO();
	}

	/**
	 * @return ProvincesDAO
	 */
	public static function getProvincesDAO(){
		return new ProvincesMySqlExtDAO();
	}

	/**
	 * @return TblActivityPurposeDAO
	 */
	public static function getTblActivityPurposeDAO(){
		return new TblActivityPurposeMySqlExtDAO();
	}

	/**
	 * @return TblAttendanceDAO
	 */
	public static function getTblAttendanceDAO(){
		return new TblAttendanceMySqlExtDAO();
	}

	/**
	 * @return TblChatAccessDAO
	 */
	public static function getTblChatAccessDAO(){
		return new TblChatAccessMySqlExtDAO();
	}

	/**
	 * @return TblClientDAO
	 */
	public static function getTblClientDAO(){
		return new TblClientMySqlExtDAO();
	}

	/**
	 * @return TblClientProjectDAO
	 */
	public static function getTblClientProjectDAO(){
		return new TblClientProjectMySqlExtDAO();
	}

	/**
	 * @return TblClientSchedDAO
	 */
	public static function getTblClientSchedDAO(){
		return new TblClientSchedMySqlExtDAO();
	}

	/**
	 * @return TblCostCenterDAO
	 */
	public static function getTblCostCenterDAO(){
		return new TblCostCenterMySqlExtDAO();
	}

	/**
	 * @return TblDefaultActivitiesDAO
	 */
	public static function getTblDefaultActivitiesDAO(){
		return new TblDefaultActivitiesMySqlExtDAO();
	}

	/**
	 * @return TblDepartmentDAO
	 */
	public static function getTblDepartmentDAO(){
		return new TblDepartmentMySqlExtDAO();
	}

	/**
	 * @return TblDprApproveDAO
	 */
	public static function getTblDprApproveDAO(){
		return new TblDprApproveMySqlExtDAO();
	}

	/**
	 * @return TblDprTransactionDAO
	 */
	public static function getTblDprTransactionDAO(){
		return new TblDprTransactionMySqlExtDAO();
	}

	/**
	 * @return TblDprecordsDAO
	 */
	public static function getTblDprecordsDAO(){
		return new TblDprecordsMySqlExtDAO();
	}

	/**
	 * @return TblEmployeeDirectoryDAO
	 */
	public static function getTblEmployeeDirectoryDAO(){
		return new TblEmployeeDirectoryMySqlExtDAO();
	}

	/**
	 * @return TblEmployeeSetupDAO
	 */
	public static function getTblEmployeeSetupDAO(){
		return new TblEmployeeSetupMySqlExtDAO();
	}

	/**
	 * @return TblEmploymentDAO
	 */
	public static function getTblEmploymentDAO(){
		return new TblEmploymentMySqlExtDAO();
	}

	/**
	 * @return TblEngagementTypeDAO
	 */
	public static function getTblEngagementTypeDAO(){
		return new TblEngagementTypeMySqlExtDAO();
	}

	/**
	 * @return TblGroupAccessDAO
	 */
	public static function getTblGroupAccessDAO(){
		return new TblGroupAccessMySqlExtDAO();
	}

	/**
	 * @return TblGroupActivityDAO
	 */
	public static function getTblGroupActivityDAO(){
		return new TblGroupActivityMySqlExtDAO();
	}

	/**
	 * @return TblGroupNameDAO
	 */
	public static function getTblGroupNameDAO(){
		return new TblGroupNameMySqlExtDAO();
	}

	/**
	 * @return TblHolidayDAO
	 */
	public static function getTblHolidayDAO(){
		return new TblHolidayMySqlExtDAO();
	}

	/**
	 * @return TblLeaveDAO
	 */
	public static function getTblLeaveDAO(){
		return new TblLeaveMySqlExtDAO();
	}

	/**
	 * @return TblLeaveCreditsDAO
	 */
	public static function getTblLeaveCreditsDAO(){
		return new TblLeaveCreditsMySqlExtDAO();
	}

	/**
	 * @return TblLogStatusDAO
	 */
	public static function getTblLogStatusDAO(){
		return new TblLogStatusMySqlExtDAO();
	}

	/**
	 * @return TblNotificationDAO
	 */
	public static function getTblNotificationDAO(){
		return new TblNotificationMySqlExtDAO();
	}

	/**
	 * @return TblPajamasBrandOfServiceDAO
	 */
	public static function getTblPajamasBrandOfServiceDAO(){
		return new TblPajamasBrandOfServiceMySqlExtDAO();
	}

	/**
	 * @return TblPlanForTomorrowDAO
	 */
	public static function getTblPlanForTomorrowDAO(){
		return new TblPlanForTomorrowMySqlExtDAO();
	}

	/**
	 * @return TblPlanRecordsDAO
	 */
	public static function getTblPlanRecordsDAO(){
		return new TblPlanRecordsMySqlExtDAO();
	}

	/**
	 * @return TblPlanTransactionDAO
	 */
	public static function getTblPlanTransactionDAO(){
		return new TblPlanTransactionMySqlExtDAO();
	}

	/**
	 * @return TblPositionRateDAO
	 */
	public static function getTblPositionRateDAO(){
		return new TblPositionRateMySqlExtDAO();
	}

	/**
	 * @return TblProjectActivitiesDAO
	 */
	public static function getTblProjectActivitiesDAO(){
		return new TblProjectActivitiesMySqlExtDAO();
	}

	/**
	 * @return TblProjectBudgetDAO
	 */
	public static function getTblProjectBudgetDAO(){
		return new TblProjectBudgetMySqlExtDAO();
	}

	/**
	 * @return TblReportSetupDAO
	 */
	public static function getTblReportSetupDAO(){
		return new TblReportSetupMySqlExtDAO();
	}

	/**
	 * @return TblRequestOtDAO
	 */
	public static function getTblRequestOtDAO(){
		return new TblRequestOtMySqlExtDAO();
	}

	/**
	 * @return TblSubordinateDAO
	 */
	public static function getTblSubordinateDAO(){
		return new TblSubordinateMySqlExtDAO();
	}

	/**
	 * @return TblTeamMemberDAO
	 */
	public static function getTblTeamMemberDAO(){
		return new TblTeamMemberMySqlExtDAO();
	}

	/**
	 * @return TblTeamSetupDAO
	 */
	public static function getTblTeamSetupDAO(){
		return new TblTeamSetupMySqlExtDAO();
	}

	/**
	 * @return TblUserDAO
	 */
	public static function getTblUserDAO(){
		return new TblUserMySqlExtDAO();
	}

	/**
	 * @return TblUser1DAO
	 */
	public static function getTblUser1DAO(){
		return new TblUser1MySqlExtDAO();
	}

	/**
	 * @return TblUserGroupDAO
	 */
	public static function getTblUserGroupDAO(){
		return new TblUserGroupMySqlExtDAO();
	}

	/**
	 * @return TblUserLogsDAO
	 */
	public static function getTblUserLogsDAO(){
		return new TblUserLogsMySqlExtDAO();
	}

	/**
	 * @return TblUserRateDAO
	 */
	public static function getTblUserRateDAO(){
		return new TblUserRateMySqlExtDAO();
	}

	/**
	 * @return TblUserinfoDAO
	 */
	public static function getTblUserinfoDAO(){
		return new TblUserinfoMySqlExtDAO();
	}

	/**
	 * @return TblWprDAO
	 */
	public static function getTblWprDAO(){
		return new TblWprMySqlExtDAO();
	}


}
?>