<?php
/**
 * Class that operate on table 'tbl_group_access'. Database Mysql.
 *
 * @author: http://phpdao.com
 * @date: 2013-02-27 03:59
 */
class TblGroupAccessMySqlExtDAO extends TblGroupAccessMySqlDAO{

    static function getGroupMemberByType($groupId, $type, $status = '',$company = '%%'){
        $userType = ($status == '' ? '' : " AND u.userStatus='".$status."' ");
        $txt = "SELECT tga.* FROM tbl_group_access tga
			INNER JOIN tbl_user u ON u.id = tga.user_id
			WHERE tga.group_id = ".$groupId." AND tga.type='".$type."' ".$userType."
			AND u.company LIKE '".$company."'
			;";
        $sqlQuery = new SqlQuery($txt);

        return self::getGroupAccess($sqlQuery);
    }

    static function searchMemberByGroup($groupId, $search = '', $company = '%%', $type = '%%'){
        $txt = "
			SELECT tga.* FROM tbl_group_access tga
			WHERE tga.user_id IN 
			(
				SELECT id FROM tbl_user WHERE 
				( 
					CONCAT(firstname,' ',midname,' ',lastname) LIKE '%".$search."%' OR
					company_id LIKE '%".$search."%'
				) AND company LIKE '".$company."'
				AND userStatus = 0
			)
			AND tga.type LIKE '".$type."'
			AND tga.group_id = ".$groupId."
		";
        $sqlQuery = new SqlQuery($txt);

        return self::getGroupAccess($sqlQuery);
    }

    static function getGroupByUser($id,$type = 1){
        $txt = "SELECT * FROM tbl_group_access WHERE user_id = ".$id." AND type='".$type."' ;";
        $sqlQuery = new SqlQuery($txt);

        return self::getGroupAccess($sqlQuery);
    }

    protected static function getGroupAccess($sqlQuery){
        $tab = QueryExecutor::execute($sqlQuery);
        if(empty($tab)){ return false; }
        $results = array();
        foreach($tab as $each){
            $result = new TblGroupAcces();
            $result->id = $each['id'];
            $result->groupId = $each['group_id'];
            $result->userId = $each['user_id'];
            $result->status = $each['status'];
            $result->type = $each['type'];
            $results[] = $result;
        }
        return $results;
    }

    function getMemberPerGroup($groupId)
    {
        $sql = "SELECT emp.*,tga.group_id FROM `tbl_group_access` tga
				LEFT JOIN tbl_user as emp ON tga.`user_id` = emp.id
				WHERE tga.`group_id` = ".$groupId." ORDER BY emp.firstname";
        $sqlQuery = new SqlQuery($sql);
        return QueryExecutor::execute($sqlQuery);
    }

    function getClientPerGroup($userId)
    {
        $sql = "SELECT * FROM `cl_clients` cc
							LEFT JOIN tbl_client_project tcp
								ON cc.id = tcp.cl_client
							LEFT JOIN tbl_group_access tga
								ON tga.group_id = tcp.grp_id
						WHERE tga.user_id = ".$userId."
						GROUP BY tcp.cl_client
						ORDER BY cc.name ASC
							
						";
        $sqlQuery = new SqlQuery($sql);
        return QueryExecutor::execute($sqlQuery);
    }

    function checkMainAccess($userId)
    {
        $sql = "SELECT * FROM tbl_group_access tga
						
							WHERE
									tga.type = 1
								AND
									tga.user_id = ".$userId."
						";
        $sqlQuery = new SqlQuery($sql);
        return QueryExecutor::execute($sqlQuery);
    }
    function getProjectByGroup($actId,$grpId)
    {
        $sql = "SELECT * FROM tbl_project_activities
							WHERE
									grp_id = ".$grpId."
								AND
									act_id = ".$actId."
					";
        $sqlQuery = new SqlQuery($sql);
        return QueryExecutor::execute($sqlQuery);
    }


    function showAssignedGroup($userId)
    {
        $sql = "SELECT tug.* FROM tbl_group_access tga
					LEFT JOIN tbl_user_group tug
						ON tug.id = tga.group_id
						
				WHERE
					tga.user_id = {$userId}
					
				ORDER BY tug.name ASC
				";
        $sqlQuery = new SqlQuery($sql);
        return QueryExecutor::execute($sqlQuery);
    }
}
?>