<?php

/**
 * DAOFactory
 * @author: http://phpdao.com
 * @date: ${date}
 */
class DAOFactory{
	
	/**
	 * @return TblAllowanceDAO
	 */
	public static function getTblAllowanceDAO(){
		return new TblAllowanceMySqlExtDAO();
	}

	/**
	 * @return TblAnalysisDAO
	 */
	public static function getTblAnalysisDAO(){
		return new TblAnalysisMySqlExtDAO();
	}

	/**
	 * @return TblAttendanceDAO
	 */
	public static function getTblAttendanceDAO(){
		return new TblAttendanceMySqlExtDAO();
	}

	/**
	 * @return TblBloodTypeDAO
	 */
	public static function getTblBloodTypeDAO(){
		return new TblBloodTypeMySqlExtDAO();
	}

	/**
	 * @return TblBudgetHoursPerPositionDAO
	 */
	public static function getTblBudgetHoursPerPositionDAO(){
		return new TblBudgetHoursPerPositionMySqlExtDAO();
	}

	/**
	 * @return TblCityDAO
	 */
	public static function getTblCityDAO(){
		return new TblCityMySqlExtDAO();
	}

	/**
	 * @return TblClientDAO
	 */
	public static function getTblClientDAO(){
		return new TblClientMySqlExtDAO();
	}

	/**
	 * @return TblClientNewDAO
	 */
	public static function getTblClientNewDAO(){
		return new TblClientNewMySqlExtDAO();
	}

	/**
	 * @return TblClientScheduleDAO
	 */
	public static function getTblClientScheduleDAO(){
		return new TblClientScheduleMySqlExtDAO();
	}

	/**
	 * @return TblClientWinDAO
	 */
	public static function getTblClientWinDAO(){
		return new TblClientWinMySqlExtDAO();
	}

	/**
	 * @return TblCompanyDAO
	 */
	public static function getTblCompanyDAO(){
		return new TblCompanyMySqlExtDAO();
	}

	/**
	 * @return TblCompanyPerDeptDAO
	 */
	public static function getTblCompanyPerDeptDAO(){
		return new TblCompanyPerDeptMySqlExtDAO();
	}

	/**
	 * @return TblCompanyPerEngDAO
	 */
	public static function getTblCompanyPerEngDAO(){
		return new TblCompanyPerEngMySqlExtDAO();
	}

	/**
	 * @return TblDailyForecastDAO
	 */
	public static function getTblDailyForecastDAO(){
		return new TblDailyForecastMySqlExtDAO();
	}

	/**
	 * @return TblDailyForecastPerTimeDAO
	 */
	public static function getTblDailyForecastPerTimeDAO(){
		return new TblDailyForecastPerTimeMySqlExtDAO();
	}

	/**
	 * @return TblDepartmentDAO
	 */
	public static function getTblDepartmentDAO(){
		return new TblDepartmentMySqlExtDAO();
	}

	/**
	 * @return TblDepartmentPerCompanyDAO
	 */
	public static function getTblDepartmentPerCompanyDAO(){
		return new TblDepartmentPerCompanyMySqlExtDAO();
	}

	/**
	 * @return TblEmployeeDirectoryDAO
	 */
	public static function getTblEmployeeDirectoryDAO(){
		return new TblEmployeeDirectoryMySqlExtDAO();
	}

	/**
	 * @return TblEmployeeStatusDAO
	 */
	public static function getTblEmployeeStatusDAO(){
		return new TblEmployeeStatusMySqlExtDAO();
	}

	/**
	 * @return TblEmploymentStatusDAO
	 */
	public static function getTblEmploymentStatusDAO(){
		return new TblEmploymentStatusMySqlExtDAO();
	}

	/**
	 * @return TblEngagementDAO
	 */
	public static function getTblEngagementDAO(){
		return new TblEngagementMySqlExtDAO();
	}

	/**
	 * @return TblEngagementPerDeptDAO
	 */
	public static function getTblEngagementPerDeptDAO(){
		return new TblEngagementPerDeptMySqlExtDAO();
	}

	/**
	 * @return TblEngagementSetupDAO
	 */
	public static function getTblEngagementSetupDAO(){
		return new TblEngagementSetupMySqlExtDAO();
	}

	/**
	 * @return TblEngagementTypeDAO
	 */
	public static function getTblEngagementTypeDAO(){
		return new TblEngagementTypeMySqlExtDAO();
	}

	/**
	 * @return TblEngagementTypePerDeptAccessDAO
	 */
	public static function getTblEngagementTypePerDeptAccessDAO(){
		return new TblEngagementTypePerDeptAccessMySqlExtDAO();
	}

	/**
	 * @return TblForecastDAO
	 */
	public static function getTblForecastDAO(){
		return new TblForecastMySqlExtDAO();
	}

	/**
	 * @return TblForecastTransactionDAO
	 */
	public static function getTblForecastTransactionDAO(){
		return new TblForecastTransactionMySqlExtDAO();
	}

	/**
	 * @return TblHolidayDAO
	 */
	public static function getTblHolidayDAO(){
		return new TblHolidayMySqlExtDAO();
	}

	/**
	 * @return TblHourCodeDAO
	 */
	public static function getTblHourCodeDAO(){
		return new TblHourCodeMySqlExtDAO();
	}

	/**
	 * @return TblKeyAccountsDAO
	 */
	public static function getTblKeyAccountsDAO(){
		return new TblKeyAccountsMySqlExtDAO();
	}

	/**
	 * @return TblLeaveDAO
	 */
	public static function getTblLeaveDAO(){
		return new TblLeaveMySqlExtDAO();
	}

	/**
	 * @return TblLeaveCreditsDAO
	 */
	public static function getTblLeaveCreditsDAO(){
		return new TblLeaveCreditsMySqlExtDAO();
	}

	/**
	 * @return TblLeaveCreditsPerTypeDAO
	 */
	public static function getTblLeaveCreditsPerTypeDAO(){
		return new TblLeaveCreditsPerTypeMySqlExtDAO();
	}

	/**
	 * @return TblLeaveCreditsPerTypeTransactionDAO
	 */
	public static function getTblLeaveCreditsPerTypeTransactionDAO(){
		return new TblLeaveCreditsPerTypeTransactionMySqlExtDAO();
	}

	/**
	 * @return TblLeaveCreditsTransactionDAO
	 */
	public static function getTblLeaveCreditsTransactionDAO(){
		return new TblLeaveCreditsTransactionMySqlExtDAO();
	}

	/**
	 * @return TblLeavePerTypeDAO
	 */
	public static function getTblLeavePerTypeDAO(){
		return new TblLeavePerTypeMySqlExtDAO();
	}

	/**
	 * @return TblLeaveRequestDAO
	 */
	public static function getTblLeaveRequestDAO(){
		return new TblLeaveRequestMySqlExtDAO();
	}

	/**
	 * @return TblLeaveTypeDAO
	 */
	public static function getTblLeaveTypeDAO(){
		return new TblLeaveTypeMySqlExtDAO();
	}

	/**
	 * @return TblMobileNetworkDAO
	 */
	public static function getTblMobileNetworkDAO(){
		return new TblMobileNetworkMySqlExtDAO();
	}

	/**
	 * @return TblModuleDAO
	 */
	public static function getTblModuleDAO(){
		return new TblModuleMySqlExtDAO();
	}

	/**
	 * @return TblMonthDAO
	 */
	public static function getTblMonthDAO(){
		return new TblMonthMySqlExtDAO();
	}

	/**
	 * @return TblNamesDAO
	 */
	public static function getTblNamesDAO(){
		return new TblNamesMySqlExtDAO();
	}

	/**
	 * @return TblNbtDAO
	 */
	public static function getTblNbtDAO(){
		return new TblNbtMySqlExtDAO();
	}

	/**
	 * @return TblNbtActualDAO
	 */
	public static function getTblNbtActualDAO(){
		return new TblNbtActualMySqlExtDAO();
	}

	/**
	 * @return TblNbtApproveDAO
	 */
	public static function getTblNbtApproveDAO(){
		return new TblNbtApproveMySqlExtDAO();
	}

	/**
	 * @return TblNbtApproveHistoryDAO
	 */
	public static function getTblNbtApproveHistoryDAO(){
		return new TblNbtApproveHistoryMySqlExtDAO();
	}

	/**
	 * @return TblNbtHoursSpentDAO
	 */
	public static function getTblNbtHoursSpentDAO(){
		return new TblNbtHoursSpentMySqlExtDAO();
	}

	/**
	 * @return TblNbtPerPositionTimeDAO
	 */
	public static function getTblNbtPerPositionTimeDAO(){
		return new TblNbtPerPositionTimeMySqlExtDAO();
	}

	/**
	 * @return TblNbtPerTbaDAO
	 */
	public static function getTblNbtPerTbaDAO(){
		return new TblNbtPerTbaMySqlExtDAO();
	}

	/**
	 * @return TblNbtTimeDAO
	 */
	public static function getTblNbtTimeDAO(){
		return new TblNbtTimeMySqlExtDAO();
	}

	/**
	 * @return TblNbtTransactionDAO
	 */
	public static function getTblNbtTransactionDAO(){
		return new TblNbtTransactionMySqlExtDAO();
	}

	/**
	 * @return TblPbsDAO
	 */
	public static function getTblPbsDAO(){
		return new TblPbsMySqlExtDAO();
	}

	/**
	 * @return TblPbsFileDAO
	 */
	public static function getTblPbsFileDAO(){
		return new TblPbsFileMySqlExtDAO();
	}

	/**
	 * @return TblPositionDAO
	 */
	public static function getTblPositionDAO(){
		return new TblPositionMySqlExtDAO();
	}

	/**
	 * @return TblProvincesDAO
	 */
	public static function getTblProvincesDAO(){
		return new TblProvincesMySqlExtDAO();
	}

	/**
	 * @return TblRatePerPositionDAO
	 */
	public static function getTblRatePerPositionDAO(){
		return new TblRatePerPositionMySqlExtDAO();
	}

	/**
	 * @return TblReimbursementDAO
	 */
	public static function getTblReimbursementDAO(){
		return new TblReimbursementMySqlExtDAO();
	}

	/**
	 * @return TblRequestOtDAO
	 */
	public static function getTblRequestOtDAO(){
		return new TblRequestOtMySqlExtDAO();
	}

	/**
	 * @return TblScopeClientDAO
	 */
	public static function getTblScopeClientDAO(){
		return new TblScopeClientMySqlExtDAO();
	}

	/**
	 * @return TblScopeOfWorkDAO
	 */
	public static function getTblScopeOfWorkDAO(){
		return new TblScopeOfWorkMySqlExtDAO();
	}

	/**
	 * @return TblServiceLineDAO
	 */
	public static function getTblServiceLineDAO(){
		return new TblServiceLineMySqlExtDAO();
	}

	/**
	 * @return TblShiftDAO
	 */
	public static function getTblShiftDAO(){
		return new TblShiftMySqlExtDAO();
	}

	/**
	 * @return TblSjcQuestionDAO
	 */
	public static function getTblSjcQuestionDAO(){
		return new TblSjcQuestionMySqlExtDAO();
	}

	/**
	 * @return TblSubdomainAccountsDAO
	 */
	public static function getTblSubdomainAccountsDAO(){
		return new TblSubdomainAccountsMySqlExtDAO();
	}

	/**
	 * @return TblSubdomainPerDeptDAO
	 */
	public static function getTblSubdomainPerDeptDAO(){
		return new TblSubdomainPerDeptMySqlExtDAO();
	}

	/**
	 * @return TblSubordinateDAO
	 */
	public static function getTblSubordinateDAO(){
		return new TblSubordinateMySqlExtDAO();
	}

	/**
	 * @return TblTbaDAO
	 */
	public static function getTblTbaDAO(){
		return new TblTbaMySqlExtDAO();
	}

	/**
	 * @return TblTbaPerEngDAO
	 */
	public static function getTblTbaPerEngDAO(){
		return new TblTbaPerEngMySqlExtDAO();
	}

	/**
	 * @return TblTimeRequestDAO
	 */
	public static function getTblTimeRequestDAO(){
		return new TblTimeRequestMySqlExtDAO();
	}

	/**
	 * @return TblTransportationModeDAO
	 */
	public static function getTblTransportationModeDAO(){
		return new TblTransportationModeMySqlExtDAO();
	}

	/**
	 * @return TblUserDAO
	 */
	public static function getTblUserDAO(){
		return new TblUserMySqlExtDAO();
	}

	/**
	 * @return TblUserImageDAO
	 */
	public static function getTblUserImageDAO(){
		return new TblUserImageMySqlExtDAO();
	}

	/**
	 * @return TblUserInfoDAO
	 */
	public static function getTblUserInfoDAO(){
		return new TblUserInfoMySqlExtDAO();
	}

	/**
	 * @return TblUserInfoOtherDAO
	 */
	public static function getTblUserInfoOtherDAO(){
		return new TblUserInfoOtherMySqlExtDAO();
	}

	/**
	 * @return TblUserModuleAccessDAO
	 */
	public static function getTblUserModuleAccessDAO(){
		return new TblUserModuleAccessMySqlExtDAO();
	}

	/**
	 * @return TblUserScheduleDAO
	 */
	public static function getTblUserScheduleDAO(){
		return new TblUserScheduleMySqlExtDAO();
	}

	/**
	 * @return TblUserSignatureDAO
	 */
	public static function getTblUserSignatureDAO(){
		return new TblUserSignatureMySqlExtDAO();
	}
	
	/**
	 * @return TblWorkingCalendarDAO
	 */
	public static function getTblWorkingCalendarDAO(){
		return new TblWorkingCalendarMySqlExtDAO();
	}


}
?>