<?php
	//include all DAO files
	require_once('class/sql/Connection.class.php');
	require_once('class/sql/ConnectionFactory.class.php');
	require_once('class/sql/ConnectionProperty.class.php');
	require_once('class/sql/QueryExecutor.class.php');
	require_once('class/sql/Transaction.class.php');
	require_once('class/sql/SqlQuery.class.php');
	require_once('class/core/ArrayList.class.php');
	require_once('class/dao/DAOFactory.class.php');
 	
	require_once('class/dao/TblAllowanceDAO.class.php');
	require_once('class/dto/TblAllowance.class.php');
	require_once('class/mysql/TblAllowanceMySqlDAO.class.php');
	require_once('class/mysql/ext/TblAllowanceMySqlExtDAO.class.php');
	require_once('class/dao/TblAnalysisDAO.class.php');
	require_once('class/dto/TblAnalysi.class.php');
	require_once('class/mysql/TblAnalysisMySqlDAO.class.php');
	require_once('class/mysql/ext/TblAnalysisMySqlExtDAO.class.php');
	require_once('class/dao/TblAttendanceDAO.class.php');
	require_once('class/dto/TblAttendance.class.php');
	require_once('class/mysql/TblAttendanceMySqlDAO.class.php');
	require_once('class/mysql/ext/TblAttendanceMySqlExtDAO.class.php');
	require_once('class/dao/TblBloodTypeDAO.class.php');
	require_once('class/dto/TblBloodType.class.php');
	require_once('class/mysql/TblBloodTypeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblBloodTypeMySqlExtDAO.class.php');
	require_once('class/dao/TblBudgetHoursPerPositionDAO.class.php');
	require_once('class/dto/TblBudgetHoursPerPosition.class.php');
	require_once('class/mysql/TblBudgetHoursPerPositionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblBudgetHoursPerPositionMySqlExtDAO.class.php');
	require_once('class/dao/TblCityDAO.class.php');
	require_once('class/dto/TblCity.class.php');
	require_once('class/mysql/TblCityMySqlDAO.class.php');
	require_once('class/mysql/ext/TblCityMySqlExtDAO.class.php');
	require_once('class/dao/TblClientDAO.class.php');
	require_once('class/dto/TblClient.class.php');
	require_once('class/mysql/TblClientMySqlDAO.class.php');
	require_once('class/mysql/ext/TblClientMySqlExtDAO.class.php');
	require_once('class/dao/TblClientScheduleDAO.class.php');
	require_once('class/dto/TblClientSchedule.class.php');
	require_once('class/mysql/TblClientScheduleMySqlDAO.class.php');
	require_once('class/mysql/ext/TblClientScheduleMySqlExtDAO.class.php');
	require_once('class/dao/TblCompanyDAO.class.php');
	require_once('class/dto/TblCompany.class.php');
	require_once('class/mysql/TblCompanyMySqlDAO.class.php');
	require_once('class/mysql/ext/TblCompanyMySqlExtDAO.class.php');
	require_once('class/dao/TblCompanyPerDeptDAO.class.php');
	require_once('class/dto/TblCompanyPerDept.class.php');
	require_once('class/mysql/TblCompanyPerDeptMySqlDAO.class.php');
	require_once('class/mysql/ext/TblCompanyPerDeptMySqlExtDAO.class.php');
	require_once('class/dao/TblDailyForecastDAO.class.php');
	require_once('class/dto/TblDailyForecast.class.php');
	require_once('class/mysql/TblDailyForecastMySqlDAO.class.php');
	require_once('class/mysql/ext/TblDailyForecastMySqlExtDAO.class.php');
	require_once('class/dao/TblDailyForecastPerTimeDAO.class.php');
	require_once('class/dto/TblDailyForecastPerTime.class.php');
	require_once('class/mysql/TblDailyForecastPerTimeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblDailyForecastPerTimeMySqlExtDAO.class.php');
	require_once('class/dao/TblDepartmentDAO.class.php');
	require_once('class/dto/TblDepartment.class.php');
	require_once('class/mysql/TblDepartmentMySqlDAO.class.php');
	require_once('class/mysql/ext/TblDepartmentMySqlExtDAO.class.php');
	require_once('class/dao/TblDepartmentPerCompanyDAO.class.php');
	require_once('class/dto/TblDepartmentPerCompany.class.php');
	require_once('class/mysql/TblDepartmentPerCompanyMySqlDAO.class.php');
	require_once('class/mysql/ext/TblDepartmentPerCompanyMySqlExtDAO.class.php');
	require_once('class/dao/TblEmployeeDirectoryDAO.class.php');
	require_once('class/dto/TblEmployeeDirectory.class.php');
	require_once('class/mysql/TblEmployeeDirectoryMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEmployeeDirectoryMySqlExtDAO.class.php');
	require_once('class/dao/TblEmployeeStatusDAO.class.php');
	require_once('class/dto/TblEmployeeStatu.class.php');
	require_once('class/mysql/TblEmployeeStatusMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEmployeeStatusMySqlExtDAO.class.php');
	require_once('class/dao/TblEmploymentStatusDAO.class.php');
	require_once('class/dto/TblEmploymentStatu.class.php');
	require_once('class/mysql/TblEmploymentStatusMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEmploymentStatusMySqlExtDAO.class.php');
	require_once('class/dao/TblEngagementDAO.class.php');
	require_once('class/dto/TblEngagement.class.php');
	require_once('class/mysql/TblEngagementMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEngagementMySqlExtDAO.class.php');
	require_once('class/dao/TblEngagementPerDeptDAO.class.php');
	require_once('class/dto/TblEngagementPerDept.class.php');
	require_once('class/mysql/TblEngagementPerDeptMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEngagementPerDeptMySqlExtDAO.class.php');
	require_once('class/dao/TblEngagementSetupDAO.class.php');
	require_once('class/dto/TblEngagementSetup.class.php');
	require_once('class/mysql/TblEngagementSetupMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEngagementSetupMySqlExtDAO.class.php');
	require_once('class/dao/TblEngagementTypeDAO.class.php');
	require_once('class/dto/TblEngagementType.class.php');
	require_once('class/mysql/TblEngagementTypeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEngagementTypeMySqlExtDAO.class.php');
	require_once('class/dao/TblEngagementTypePerDeptAccessDAO.class.php');
	require_once('class/dto/TblEngagementTypePerDeptAcces.class.php');
	require_once('class/mysql/TblEngagementTypePerDeptAccessMySqlDAO.class.php');
	require_once('class/mysql/ext/TblEngagementTypePerDeptAccessMySqlExtDAO.class.php');
	require_once('class/dao/TblForecastDAO.class.php');
	require_once('class/dto/TblForecast.class.php');
	require_once('class/mysql/TblForecastMySqlDAO.class.php');
	require_once('class/mysql/ext/TblForecastMySqlExtDAO.class.php');
	require_once('class/dao/TblForecastTransactionDAO.class.php');
	require_once('class/dto/TblForecastTransaction.class.php');
	require_once('class/mysql/TblForecastTransactionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblForecastTransactionMySqlExtDAO.class.php');
	require_once('class/dao/TblHolidayDAO.class.php');
	require_once('class/dto/TblHoliday.class.php');
	require_once('class/mysql/TblHolidayMySqlDAO.class.php');
	require_once('class/mysql/ext/TblHolidayMySqlExtDAO.class.php');
	require_once('class/dao/TblHourCodeDAO.class.php');
	require_once('class/dto/TblHourCode.class.php');
	require_once('class/mysql/TblHourCodeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblHourCodeMySqlExtDAO.class.php');
	require_once('class/dao/TblKeyAccountsDAO.class.php');
	require_once('class/dto/TblKeyAccount.class.php');
	require_once('class/mysql/TblKeyAccountsMySqlDAO.class.php');
	require_once('class/mysql/ext/TblKeyAccountsMySqlExtDAO.class.php');
	require_once('class/dao/TblLeaveDAO.class.php');
	require_once('class/dto/TblLeave.class.php');
	require_once('class/mysql/TblLeaveMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeaveMySqlExtDAO.class.php');
	require_once('class/dao/TblLeaveCreditsDAO.class.php');
	require_once('class/dto/TblLeaveCredit.class.php');
	require_once('class/mysql/TblLeaveCreditsMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeaveCreditsMySqlExtDAO.class.php');
	require_once('class/dao/TblLeaveCreditsPerTypeDAO.class.php');
	require_once('class/dto/TblLeaveCreditsPerType.class.php');
	require_once('class/mysql/TblLeaveCreditsPerTypeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeaveCreditsPerTypeMySqlExtDAO.class.php');
	require_once('class/dao/TblLeaveCreditsPerTypeTransactionDAO.class.php');
	require_once('class/dto/TblLeaveCreditsPerTypeTransaction.class.php');
	require_once('class/mysql/TblLeaveCreditsPerTypeTransactionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeaveCreditsPerTypeTransactionMySqlExtDAO.class.php');
	require_once('class/dao/TblLeaveCreditsTransactionDAO.class.php');
	require_once('class/dto/TblLeaveCreditsTransaction.class.php');
	require_once('class/mysql/TblLeaveCreditsTransactionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeaveCreditsTransactionMySqlExtDAO.class.php');
	require_once('class/dao/TblLeavePerTypeDAO.class.php');
	require_once('class/dto/TblLeavePerType.class.php');
	require_once('class/mysql/TblLeavePerTypeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeavePerTypeMySqlExtDAO.class.php');
	require_once('class/dao/TblLeaveRequestDAO.class.php');
	require_once('class/dto/TblLeaveRequest.class.php');
	require_once('class/mysql/TblLeaveRequestMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeaveRequestMySqlExtDAO.class.php');
	require_once('class/dao/TblLeaveTypeDAO.class.php');
	require_once('class/dto/TblLeaveType.class.php');
	require_once('class/mysql/TblLeaveTypeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblLeaveTypeMySqlExtDAO.class.php');
	require_once('class/dao/TblMobileNetworkDAO.class.php');
	require_once('class/dto/TblMobileNetwork.class.php');
	require_once('class/mysql/TblMobileNetworkMySqlDAO.class.php');
	require_once('class/mysql/ext/TblMobileNetworkMySqlExtDAO.class.php');
	require_once('class/dao/TblModuleDAO.class.php');
	require_once('class/dto/TblModule.class.php');
	require_once('class/mysql/TblModuleMySqlDAO.class.php');
	require_once('class/mysql/ext/TblModuleMySqlExtDAO.class.php');
	require_once('class/dao/TblMonthDAO.class.php');
	require_once('class/dto/TblMonth.class.php');
	require_once('class/mysql/TblMonthMySqlDAO.class.php');
	require_once('class/mysql/ext/TblMonthMySqlExtDAO.class.php');
	require_once('class/dao/TblNamesDAO.class.php');
	require_once('class/dto/TblName.class.php');
	require_once('class/mysql/TblNamesMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNamesMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtDAO.class.php');
	require_once('class/dto/TblNbt.class.php');
	require_once('class/mysql/TblNbtMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtActualDAO.class.php');
	require_once('class/dto/TblNbtActual.class.php');
	require_once('class/mysql/TblNbtActualMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtActualMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtApproveDAO.class.php');
	require_once('class/dto/TblNbtApprove.class.php');
	require_once('class/mysql/TblNbtApproveMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtApproveMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtApproveHistoryDAO.class.php');
	require_once('class/dto/TblNbtApproveHistory.class.php');
	require_once('class/mysql/TblNbtApproveHistoryMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtApproveHistoryMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtHoursSpentDAO.class.php');
	require_once('class/dto/TblNbtHoursSpent.class.php');
	require_once('class/mysql/TblNbtHoursSpentMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtHoursSpentMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtPerPositionTimeDAO.class.php');
	require_once('class/dto/TblNbtPerPositionTime.class.php');
	require_once('class/mysql/TblNbtPerPositionTimeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtPerPositionTimeMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtPerTbaDAO.class.php');
	require_once('class/dto/TblNbtPerTba.class.php');
	require_once('class/mysql/TblNbtPerTbaMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtPerTbaMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtTimeDAO.class.php');
	require_once('class/dto/TblNbtTime.class.php');
	require_once('class/mysql/TblNbtTimeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtTimeMySqlExtDAO.class.php');
	require_once('class/dao/TblNbtTransactionDAO.class.php');
	require_once('class/dto/TblNbtTransaction.class.php');
	require_once('class/mysql/TblNbtTransactionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblNbtTransactionMySqlExtDAO.class.php');
	require_once('class/dao/TblPbsDAO.class.php');
	require_once('class/dto/TblPb.class.php');
	require_once('class/mysql/TblPbsMySqlDAO.class.php');
	require_once('class/mysql/ext/TblPbsMySqlExtDAO.class.php');
	require_once('class/dao/TblPbsFileDAO.class.php');
	require_once('class/dto/TblPbsFile.class.php');
	require_once('class/mysql/TblPbsFileMySqlDAO.class.php');
	require_once('class/mysql/ext/TblPbsFileMySqlExtDAO.class.php');
	require_once('class/dao/TblPositionDAO.class.php');
	require_once('class/dto/TblPosition.class.php');
	require_once('class/mysql/TblPositionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblPositionMySqlExtDAO.class.php');
	require_once('class/dao/TblProvincesDAO.class.php');
	require_once('class/dto/TblProvince.class.php');
	require_once('class/mysql/TblProvincesMySqlDAO.class.php');
	require_once('class/mysql/ext/TblProvincesMySqlExtDAO.class.php');
	require_once('class/dao/TblRatePerPositionDAO.class.php');
	require_once('class/dto/TblRatePerPosition.class.php');
	require_once('class/mysql/TblRatePerPositionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblRatePerPositionMySqlExtDAO.class.php');
	require_once('class/dao/TblReimbursementDAO.class.php');
	require_once('class/dto/TblReimbursement.class.php');
	require_once('class/mysql/TblReimbursementMySqlDAO.class.php');
	require_once('class/mysql/ext/TblReimbursementMySqlExtDAO.class.php');
	require_once('class/dao/TblRequestOtDAO.class.php');
	require_once('class/dto/TblRequestOt.class.php');
	require_once('class/mysql/TblRequestOtMySqlDAO.class.php');
	require_once('class/mysql/ext/TblRequestOtMySqlExtDAO.class.php');
	require_once('class/dao/TblShiftDAO.class.php');
	require_once('class/dto/TblShift.class.php');
	require_once('class/mysql/TblShiftMySqlDAO.class.php');
	require_once('class/mysql/ext/TblShiftMySqlExtDAO.class.php');
	require_once('class/dao/TblSjcQuestionDAO.class.php');
	require_once('class/dto/TblSjcQuestion.class.php');
	require_once('class/mysql/TblSjcQuestionMySqlDAO.class.php');
	require_once('class/mysql/ext/TblSjcQuestionMySqlExtDAO.class.php');
	require_once('class/dao/TblSubdomainAccountsDAO.class.php');
	require_once('class/dto/TblSubdomainAccount.class.php');
	require_once('class/mysql/TblSubdomainAccountsMySqlDAO.class.php');
	require_once('class/mysql/ext/TblSubdomainAccountsMySqlExtDAO.class.php');
	require_once('class/dao/TblSubdomainPerDeptDAO.class.php');
	require_once('class/dto/TblSubdomainPerDept.class.php');
	require_once('class/mysql/TblSubdomainPerDeptMySqlDAO.class.php');
	require_once('class/mysql/ext/TblSubdomainPerDeptMySqlExtDAO.class.php');
	require_once('class/dao/TblSubordinateDAO.class.php');
	require_once('class/dto/TblSubordinate.class.php');
	require_once('class/mysql/TblSubordinateMySqlDAO.class.php');
	require_once('class/mysql/ext/TblSubordinateMySqlExtDAO.class.php');
	require_once('class/dao/TblTbaDAO.class.php');
	require_once('class/dto/TblTba.class.php');
	require_once('class/mysql/TblTbaMySqlDAO.class.php');
	require_once('class/mysql/ext/TblTbaMySqlExtDAO.class.php');
	require_once('class/dao/TblTbaPerEngDAO.class.php');
	require_once('class/dto/TblTbaPerEng.class.php');
	require_once('class/mysql/TblTbaPerEngMySqlDAO.class.php');
	require_once('class/mysql/ext/TblTbaPerEngMySqlExtDAO.class.php');
	require_once('class/dao/TblTimeRequestDAO.class.php');
	require_once('class/dto/TblTimeRequest.class.php');
	require_once('class/mysql/TblTimeRequestMySqlDAO.class.php');
	require_once('class/mysql/ext/TblTimeRequestMySqlExtDAO.class.php');
	require_once('class/dao/TblTransportationModeDAO.class.php');
	require_once('class/dto/TblTransportationMode.class.php');
	require_once('class/mysql/TblTransportationModeMySqlDAO.class.php');
	require_once('class/mysql/ext/TblTransportationModeMySqlExtDAO.class.php');
	require_once('class/dao/TblUserDAO.class.php');
	require_once('class/dto/TblUser.class.php');
	require_once('class/mysql/TblUserMySqlDAO.class.php');
	require_once('class/mysql/ext/TblUserMySqlExtDAO.class.php');
	require_once('class/dao/TblUserImageDAO.class.php');
	require_once('class/dto/TblUserImage.class.php');
	require_once('class/mysql/TblUserImageMySqlDAO.class.php');
	require_once('class/mysql/ext/TblUserImageMySqlExtDAO.class.php');
	require_once('class/dao/TblUserInfoDAO.class.php');
	require_once('class/dto/TblUserInfo.class.php');
	require_once('class/mysql/TblUserInfoMySqlDAO.class.php');
	require_once('class/mysql/ext/TblUserInfoMySqlExtDAO.class.php');
	require_once('class/dao/TblUserInfoOtherDAO.class.php');
	require_once('class/dto/TblUserInfoOther.class.php');
	require_once('class/mysql/TblUserInfoOtherMySqlDAO.class.php');
	require_once('class/mysql/ext/TblUserInfoOtherMySqlExtDAO.class.php');
	require_once('class/dao/TblUserModuleAccessDAO.class.php');
	require_once('class/dto/TblUserModuleAcces.class.php');
	require_once('class/mysql/TblUserModuleAccessMySqlDAO.class.php');
	require_once('class/mysql/ext/TblUserModuleAccessMySqlExtDAO.class.php');
	require_once('class/dao/TblUserScheduleDAO.class.php');
	require_once('class/dto/TblUserSchedule.class.php');
	require_once('class/mysql/TblUserScheduleMySqlDAO.class.php');
	require_once('class/mysql/ext/TblUserScheduleMySqlExtDAO.class.php');
	require_once('class/dao/TblUserSignatureDAO.class.php');
	require_once('class/dto/TblUserSignature.class.php');
	require_once('class/mysql/TblUserSignatureMySqlDAO.class.php');
	require_once('class/mysql/ext/TblUserSignatureMySqlExtDAO.class.php');
	require_once('class/dao/TblWorkingCalendarDAO.class.php');
	require_once('class/dto/TblWorkingCalendar.class.php');
	require_once('class/mysql/TblWorkingCalendarMySqlDAO.class.php');
	require_once('class/mysql/ext/TblWorkingCalendarMySqlExtDAO.class.php');

?>